;demo06-04.bb - Demonstrating orbiting
; ------------------
Graphics3D 640,480 
SetBuffer BackBuffer()

;Key constants
Const ESC_KEY = 1

; Create camera 
camera=CreateCamera()
PositionEntity camera,0,0,-10

; Create a light 
light=CreateLight()
RotateEntity light,90,0,0

;Create the Sun 
sun = CreateSphere(16) 
ScaleEntity sun, 2,2,2 
PositionEntity sun, 2,3,1 

;Give a texture to the sun
tex=LoadTexture( "sunskin.jpg" ) 
EntityTexture sun,tex

; Create a pivot. 
pivot = CreatePivot() 
PositionEntity pivot,2,3,1

; Create the planet earth. Make the pivot the parent of the earth. 
earth = CreateSphere(16,pivot) 
tex1 = LoadTexture( "earthskin.jpg" )
EntityTexture earth, tex1

; Position planet so that it is offset from the sun 
PositionEntity earth,5,0,0 

; This following code runs the simulation
While Not KeyDown(ESC_KEY)
	
	; Turn pivot, making planet orbit around the pivot point. 
	TurnEntity pivot,0,1,0
	; Rotate the earth. 
	pitch#=pitch#+1 
	RotateEntity earth,pitch#,yaw#,roll#
RenderWorld 

	Flip
Wend
End